<!DOCTYPE html><html lang="zh-CN" data-theme="light"><head><meta charset="UTF-8"><meta http-equiv="X-UA-Compatible" content="IE=edge"><meta name="viewport" content="width=device-width,initial-scale=1"><title>Ingress HTTP代理访问 | SeMaik</title><meta name="author" content="ZuSir"><meta name="copyright" content="ZuSir"><meta name="format-detection" content="telephone=no"><meta name="theme-color" content="#ffffff"><meta name="description" content="有了NodePort为什么用Ingress？NodePort得缺点：  是一个端口只能一个服务使用，端口需提前规划 只支持四成负载均衡  Ingrass Controller是什么？Ingress管理得负载均衡器，为集群提供全局得负载均衡能力； Ingress是什么？Ingress公开了从集群外部到集群内部服务得http和https路由，流量路由有Ingress资源上定义的规则控制； 转发流程图：">
<meta property="og:type" content="article">
<meta property="og:title" content="Ingress HTTP代理访问">
<meta property="og:url" content="http://example.com/2021/08/27/Ingress-HTTP%E4%BB%A3%E7%90%86%E8%AE%BF%E9%97%AE/index.html">
<meta property="og:site_name" content="SeMaik">
<meta property="og:description" content="有了NodePort为什么用Ingress？NodePort得缺点：  是一个端口只能一个服务使用，端口需提前规划 只支持四成负载均衡  Ingrass Controller是什么？Ingress管理得负载均衡器，为集群提供全局得负载均衡能力； Ingress是什么？Ingress公开了从集群外部到集群内部服务得http和https路由，流量路由有Ingress资源上定义的规则控制； 转发流程图：">
<meta property="og:locale" content="zh_CN">
<meta property="og:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg">
<meta property="article:published_time" content="2021-08-27T08:20:00.000Z">
<meta property="article:modified_time" content="2021-08-27T08:24:56.000Z">
<meta property="article:author" content="ZuSir">
<meta name="twitter:card" content="summary">
<meta name="twitter:image" content="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg"><link rel="shortcut icon" href="https://myit.icu/favicon.ico"><link rel="canonical" href="http://example.com/2021/08/27/Ingress-HTTP%E4%BB%A3%E7%90%86%E8%AE%BF%E9%97%AE/"><link rel="preconnect" href="//cdn.jsdelivr.net"/><link rel="preconnect" href="//busuanzi.ibruce.info"/><link rel="stylesheet" href="/css/index.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@fortawesome/fontawesome-free/css/all.min.css" media="print" onload="this.media='all'"><script>const GLOBAL_CONFIG = { 
  root: '/',
  algolia: undefined,
  localSearch: undefined,
  translate: undefined,
  noticeOutdate: undefined,
  highlight: {"plugin":"highlighjs","highlightCopy":true,"highlightLang":true},
  copy: {
    success: '复制成功',
    error: '复制错误',
    noSupport: '浏览器不支持'
  },
  relativeDate: {
    homepage: true,
    post: false
  },
  runtime: '',
  date_suffix: {
    just: '刚刚',
    min: '分钟前',
    hour: '小时前',
    day: '天前',
    month: '个月前'
  },
  copyright: undefined,
  lightbox: 'fancybox',
  Snackbar: undefined,
  source: {
    jQuery: 'https://cdn.jsdelivr.net/npm/jquery@latest/dist/jquery.min.js',
    justifiedGallery: {
      js: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/js/jquery.justifiedGallery.min.js',
      css: 'https://cdn.jsdelivr.net/npm/justifiedGallery/dist/css/justifiedGallery.min.css'
    },
    fancybox: {
      js: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.js',
      css: 'https://cdn.jsdelivr.net/npm/@fancyapps/fancybox@latest/dist/jquery.fancybox.min.css'
    }
  },
  isPhotoFigcaption: false,
  islazyload: false,
  isanchor: false
}</script><script id="config-diff">var GLOBAL_CONFIG_SITE = { 
  isPost: true,
  isHome: false,
  isHighlightShrink: undefined,
  isToc: true,
  postUpdate: '2021-08-27 16:24:56'
}</script><noscript><style type="text/css">
  #nav {
    opacity: 1
  }
  .justified-gallery img {
    opacity: 1
  }

  #recent-posts time,
  #post-meta time {
    display: inline !important
  }
</style></noscript><script>(win=>{
    win.saveToLocal = {
      set: function setWithExpiry(key, value, ttl) {
        if (ttl === 0) return
        const now = new Date()
        const expiryDay = ttl * 86400000
        const item = {
          value: value,
          expiry: now.getTime() + expiryDay,
        }
        localStorage.setItem(key, JSON.stringify(item))
      },

      get: function getWithExpiry(key) {
        const itemStr = localStorage.getItem(key)

        if (!itemStr) {
          return undefined
        }
        const item = JSON.parse(itemStr)
        const now = new Date()

        if (now.getTime() > item.expiry) {
          localStorage.removeItem(key)
          return undefined
        }
        return item.value
      }
    }
  
    win.getScript = url => new Promise((resolve, reject) => {
      const script = document.createElement('script')
      script.src = url
      script.async = true
      script.onerror = reject
      script.onload = script.onreadystatechange = function() {
        const loadState = this.readyState
        if (loadState && loadState !== 'loaded' && loadState !== 'complete') return
        script.onload = script.onreadystatechange = null
        resolve()
      }
      document.head.appendChild(script)
    })
  
      const asideStatus = saveToLocal.get('aside-status')
      if (asideStatus !== undefined) {
        if (asideStatus === 'hide') {
          document.documentElement.classList.add('hide-aside')
        } else {
          document.documentElement.classList.remove('hide-aside')
        }
      }
    })(window)</script><link href="/css/style.css"><meta name="generator" content="Hexo 5.3.0"><link rel="alternate" href="/atom.xml" title="SeMaik" type="application/atom+xml">
</head><body><div id="web_bg"></div><div id="sidebar"><div id="menu-mask"></div><div id="sidebar-menus"><div class="author-avatar"><img class="avatar-img" src="/img/123.jpeg" onerror="onerror=null;src='/img/123.jpeg'" alt="avatar"/></div><div class="site-data"><div class="data-item is-center"><div class="data-item-link"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div></div><div class="data-item is-center"><div class="data-item-link"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><hr/><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div></div></div><div class="post" id="body-wrap"><header class="post-bg" id="page-header" style="background-image: url('https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg')"><nav id="nav"><span id="blog_name"><a id="site-name" href="/">SeMaik</a></span><div id="menus"><div class="menus_items"><div class="menus_item"><a class="site-page" href="/"><i class="fa-fw fas fa-home"></i><span> 首页</span></a></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Linux</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Linux/"><span> Linux</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> WEB</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Apache/"><span> Apache</span></a></li><li><a class="site-page" href="/categories/Nginx/"><span> Nginx</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 存储</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ceph/"><span> Ceph</span></a></li><li><a class="site-page" href="/categories/NFS/"><span> NFS</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 日志</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Loki"><span> Loki</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 编程</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Shell"><span> Shell</span></a></li><li><a class="site-page" href="/categories/Python"><span> Python</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 高可用</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/KeepAlived/"><span> KeepAlived</span></a></li><li><a class="site-page" href="/categories/LVS/"><span> LVS</span></a></li><li><a class="site-page" href="/categories/Squid/"><span> Squid</span></a></li><li><a class="site-page" href="/categories/Haproxy/"><span> Haproxy</span></a></li><li><a class="site-page" href="/categories/Rsync/"><span> Rsync</span></a></li><li><a class="site-page" href="/categories/Memcache/"><span> Memcache</span></a></li><li><a class="site-page" href="/categories/Varnish/"><span> Varnish</span></a></li><li><a class="site-page" href="/categories/GRedis/"><span> Redis</span></a></li><li><a class="site-page" href="/categories/Rabbit/"><span> RabbitMQ</span></a></li><li><a class="site-page" href="/categories/Kafka/"><span> Kafka</span></a></li><li><a class="site-page" href="/categories/MHA/"><span> MHA</span></a></li><li><a class="site-page" href="/categories/PXC/"><span> PXC</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 虚拟化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Docker/"><span> Docker</span></a></li><li><a class="site-page" href="/categories/Kubernetes/"><span> Kubernetes</span></a></li><li><a class="site-page" href="/categories/OpenStack/"><span> OpenStack</span></a></li><li><a class="site-page" href="/categories/KVM/"><span> KVM</span></a></li><li><a class="site-page" href="/categories/Containerd"><span> Containerd</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> Hexo</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Hexo/"><span> Hexo</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 数据库</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/MySQL/"><span> MySQL</span></a></li><li><a class="site-page" href="/categories/Readis/"><span> Readis</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 微服务</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Tomcat/"><span> Tomcat</span></a></li><li><a class="site-page" href="/categories/Git/"><span> Git</span></a></li><li><a class="site-page" href="/categories/Maven/"><span> Maven</span></a></li><li><a class="site-page" href="/categories/Nexus/"><span> Nexus</span></a></li><li><a class="site-page" href="/categories/Jenkins/"><span> Jenkins</span></a></li><li><a class="site-page" href="/categories/Spring/"><span> Spring</span></a></li><li><a class="site-page" href="/categories/Consul/"><span> Consul</span></a></li><li><a class="site-page" href="/categories/Harbor/"><span> Harbor</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="javascript:void(0);"><i class="fa-fw /categories/"></i><span> 自动化</span><i class="fas fa-chevron-down expand"></i></a><ul class="menus_item_child"><li><a class="site-page" href="/categories/Ansible/"><span> Ansible</span></a></li><li><a class="site-page" href="/categories/Pssh/"><span> Pssh</span></a></li></ul></div><div class="menus_item"><a class="site-page" href="/link/"><i class="fa-fw fas fa-link"></i><span> 友链</span></a></div><div class="menus_item"><a class="site-page" href="/about/"><i class="fa-fw fas fa-heart"></i><span> 关于</span></a></div></div><div id="toggle-menu"><a class="site-page"><i class="fas fa-bars fa-fw"></i></a></div></div></nav><div id="post-info"><h1 class="post-title">Ingress HTTP代理访问</h1><div id="post-meta"><div class="meta-firstline"><span class="post-meta-date"><i class="far fa-calendar-alt fa-fw post-meta-icon"></i><span class="post-meta-label">发表于</span><time class="post-meta-date-created" datetime="2021-08-27T08:20:00.000Z" title="发表于 2021-08-27 16:20:00">2021-08-27</time><span class="post-meta-separator">|</span><i class="fas fa-history fa-fw post-meta-icon"></i><span class="post-meta-label">更新于</span><time class="post-meta-date-updated" datetime="2021-08-27T08:24:56.000Z" title="更新于 2021-08-27 16:24:56">2021-08-27</time></span><span class="post-meta-categories"><span class="post-meta-separator">|</span><i class="fas fa-inbox fa-fw post-meta-icon"></i><a class="post-meta-categories" href="/categories/Kubernetes/">Kubernetes</a></span></div><div class="meta-secondline"><span class="post-meta-separator">|</span><span class="post-meta-pv-cv"><i class="far fa-eye fa-fw post-meta-icon"></i><span class="post-meta-label">阅读量:</span><span id="busuanzi_value_page_pv"></span></span></div></div></div></header><main class="layout" id="content-inner"><div id="post"><article class="post-content" id="article-container"><h3 id="有了NodePort为什么用Ingress？"><a href="#有了NodePort为什么用Ingress？" class="headerlink" title="有了NodePort为什么用Ingress？"></a>有了NodePort为什么用Ingress？</h3><p>NodePort得缺点：</p>
<ul>
<li>是一个端口只能一个服务使用，端口需提前规划</li>
<li>只支持四成负载均衡</li>
</ul>
<h3 id="Ingrass-Controller是什么？"><a href="#Ingrass-Controller是什么？" class="headerlink" title="Ingrass Controller是什么？"></a>Ingrass Controller是什么？</h3><p>Ingress管理得负载均衡器，为集群提供全局得负载均衡能力；</p>
<h3 id="Ingress是什么？"><a href="#Ingress是什么？" class="headerlink" title="Ingress是什么？"></a>Ingress是什么？</h3><p>Ingress公开了从集群外部到集群内部服务得http和https路由，流量路由有Ingress资源上定义的规则控制；</p>
<p>转发流程图：</p>
<p><img src="/images/pasted-254.png" alt="upload successful"></p>
<h3 id="Ingress使用流程："><a href="#Ingress使用流程：" class="headerlink" title="Ingress使用流程："></a>Ingress使用流程：</h3><p>1、部署Ingress Controller</p>
<p>2、部署Ingress Pod规则</p>
<p>注：如果不同命名空间得SVC想互相调用，需要在SVC后面加个”.{namespace_name}”</p>
<h3 id="ingress两种转发模式"><a href="#ingress两种转发模式" class="headerlink" title="ingress两种转发模式"></a>ingress两种转发模式</h3><p>1、ingress部署完成之后需要部署svc对ingress端口进行暴露</p>
<p>​      user -&gt; svc(nodeport) -&gt; ingress controller pod -&gt; 节点Pod</p>
<p>2、添加hostNetwork将ingress端口应用到物理机中</p>
<p>​      user -&gt; ingress controller pod -&gt; 节点Pod</p>
<p>推荐第二种，性能会高与第一种；</p>
<h3 id="高可用Ingress演示-http代理访问"><a href="#高可用Ingress演示-http代理访问" class="headerlink" title="高可用Ingress演示(http代理访问)"></a>高可用Ingress演示(http代理访问)</h3><h4 id="部署keepalived"><a href="#部署keepalived" class="headerlink" title="部署keepalived"></a>部署keepalived</h4><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br></pre></td><td class="code"><pre><span class="line"><span class="comment"># Node节点部署（在需要部署Ingress Controller节点下部署）</span></span><br><span class="line"></span><br><span class="line"><span class="comment"># Node1：</span></span><br><span class="line">[root@pool2 ~]<span class="comment"># yum -y install keepalived</span></span><br><span class="line">[root@pool2 ~]<span class="comment"># vi /etc/keepalived/keepalived.conf</span></span><br><span class="line">! Configuration File <span class="keyword">for</span> keepalived</span><br><span class="line"></span><br><span class="line">global_defs &#123;</span><br><span class="line">   router_id ingress</span><br><span class="line">&#125;</span><br><span class="line"></span><br><span class="line">vrrp_instance VI_1 &#123;</span><br><span class="line">    state MASTER</span><br><span class="line">    interface ens33</span><br><span class="line">    virtual_router_id 51</span><br><span class="line">    priority 100</span><br><span class="line">    advert_int 1</span><br><span class="line">    authentication &#123;</span><br><span class="line">        auth_type ingress</span><br><span class="line">        auth_pass ingress</span><br><span class="line">    &#125;</span><br><span class="line">    virtual_ipaddress &#123;</span><br><span class="line">        172.16.1.23 dev ens33 label ens33:1</span><br><span class="line">    &#125;</span><br><span class="line">&#125;</span><br><span class="line">[root@pool2 ~]<span class="comment"># scp /etc/keepalived/keepalived.conf root@172.16.1.22:/etc/keepalived/</span></span><br><span class="line">[root@pool2 ~]<span class="comment"># systemctl restart keepalived</span></span><br><span class="line">[root@pool2 ~]<span class="comment"># ip a| grep ens33:1</span></span><br><span class="line">    inet 172.16.1.23/32 scope global ens33:1</span><br><span class="line">    </span><br><span class="line"><span class="comment"># Node2：</span></span><br><span class="line">[root@pool3 ~]<span class="comment"># yum -y install keepalived</span></span><br><span class="line">[root@pool3 ~]<span class="comment"># sed -i &#x27;s/MASTER/BACKUP/g&#x27; /etc/keepalived/keepalived.conf </span></span><br><span class="line">[root@pool3 ~]<span class="comment"># sed -i &#x27;s/100/99/g&#x27; /etc/keepalived/keepalived.conf</span></span><br><span class="line">[root@pool3 ~]<span class="comment"># systemctl restart keepalived</span></span><br></pre></td></tr></table></figure>
<p>有必要得情况下加一个HAproxy</p>
<h4 id="创建nginx-pod"><a href="#创建nginx-pod" class="headerlink" title="创建nginx pod"></a>创建nginx pod</h4><figure class="highlight yaml"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br><span class="line">25</span><br><span class="line">26</span><br><span class="line">27</span><br><span class="line">28</span><br><span class="line">29</span><br><span class="line">30</span><br><span class="line">31</span><br><span class="line">32</span><br><span class="line">33</span><br><span class="line">34</span><br><span class="line">35</span><br><span class="line">36</span><br><span class="line">37</span><br><span class="line">38</span><br><span class="line">39</span><br><span class="line">40</span><br><span class="line">41</span><br><span class="line">42</span><br><span class="line">43</span><br><span class="line">44</span><br><span class="line">45</span><br><span class="line">46</span><br><span class="line">47</span><br><span class="line">48</span><br><span class="line">49</span><br><span class="line">50</span><br><span class="line">51</span><br><span class="line">52</span><br><span class="line">53</span><br><span class="line">54</span><br><span class="line">55</span><br><span class="line">56</span><br><span class="line">57</span><br><span class="line">58</span><br><span class="line">59</span><br><span class="line">60</span><br><span class="line">61</span><br><span class="line">62</span><br><span class="line">63</span><br><span class="line">64</span><br><span class="line">65</span><br><span class="line">66</span><br><span class="line">67</span><br><span class="line">68</span><br><span class="line">69</span><br><span class="line">70</span><br><span class="line">71</span><br><span class="line">72</span><br><span class="line">73</span><br><span class="line">74</span><br><span class="line">75</span><br><span class="line">76</span><br><span class="line">77</span><br><span class="line">78</span><br><span class="line">79</span><br><span class="line">80</span><br><span class="line">81</span><br><span class="line">82</span><br><span class="line">83</span><br><span class="line">84</span><br><span class="line">85</span><br><span class="line">86</span><br><span class="line">87</span><br><span class="line">88</span><br><span class="line">89</span><br><span class="line">90</span><br><span class="line">91</span><br><span class="line">92</span><br><span class="line">93</span><br><span class="line">94</span><br><span class="line">95</span><br><span class="line">96</span><br><span class="line">97</span><br><span class="line">98</span><br><span class="line">99</span><br><span class="line">100</span><br><span class="line">101</span><br><span class="line">102</span><br><span class="line">103</span><br><span class="line">104</span><br><span class="line">105</span><br><span class="line">106</span><br><span class="line">107</span><br><span class="line">108</span><br><span class="line">109</span><br><span class="line">110</span><br><span class="line">111</span><br><span class="line">112</span><br><span class="line">113</span><br><span class="line">114</span><br><span class="line">115</span><br><span class="line">116</span><br><span class="line">117</span><br><span class="line">118</span><br><span class="line">119</span><br><span class="line">120</span><br><span class="line">121</span><br><span class="line">122</span><br><span class="line">123</span><br><span class="line">124</span><br><span class="line">125</span><br><span class="line">126</span><br><span class="line">127</span><br><span class="line">128</span><br><span class="line">129</span><br><span class="line">130</span><br><span class="line">131</span><br><span class="line">132</span><br><span class="line">133</span><br><span class="line">134</span><br><span class="line">135</span><br><span class="line">136</span><br><span class="line">137</span><br><span class="line">138</span><br></pre></td><td class="code"><pre><span class="line">[<span class="string">root@pool1</span> <span class="string">k8s_yaml</span>]<span class="comment"># vi nginx2-pod.yaml</span></span><br><span class="line"><span class="meta">---</span></span><br><span class="line"><span class="comment"># 部署namespace</span></span><br><span class="line"><span class="attr">apiVersion:</span> <span class="string">v1</span></span><br><span class="line"><span class="attr">kind:</span> <span class="string">Namespace</span></span><br><span class="line"><span class="attr">metadata:</span></span><br><span class="line">  <span class="attr">name:</span> <span class="string">nginx-ns</span></span><br><span class="line">  <span class="attr">labels:</span></span><br><span class="line">    <span class="attr">name:</span> <span class="string">nginx-ns</span></span><br><span class="line"></span><br><span class="line"><span class="meta">---</span></span><br><span class="line"><span class="comment"># 配置页面文件</span></span><br><span class="line"><span class="attr">apiVersion:</span> <span class="string">v1</span></span><br><span class="line"><span class="attr">kind:</span> <span class="string">ConfigMap</span></span><br><span class="line"><span class="attr">metadata:</span></span><br><span class="line">  <span class="attr">name:</span> <span class="string">nginx-html</span></span><br><span class="line">  <span class="attr">namespace:</span> <span class="string">nginx-ns</span></span><br><span class="line"><span class="attr">data:</span></span><br><span class="line">  <span class="attr">index.html:</span> <span class="string">|</span></span><br><span class="line">    <span class="string">&lt;html</span> <span class="string">lang=&quot;zh-CN&quot;&gt;</span></span><br><span class="line">    <span class="string">&lt;head&gt;</span></span><br><span class="line">        <span class="string">&lt;meta</span> <span class="string">charset=&quot;utf-8&quot;&gt;</span></span><br><span class="line">        <span class="string">&lt;meta</span> <span class="string">http-equiv=&quot;X-UA-Compatible&quot;</span> <span class="string">content=&quot;IE=edge&quot;&gt;</span></span><br><span class="line">        <span class="string">&lt;meta</span> <span class="string">name=&quot;viewport&quot;</span> <span class="string">content=&quot;width=device-width,</span> <span class="string">initial-scale=1&quot;&gt;</span></span><br><span class="line">        <span class="string">&lt;!--</span> <span class="string">上述3个meta标签*必须*放在最前面，任何其他内容都*必须*跟随其后！</span> <span class="string">--&gt;</span></span><br><span class="line">        <span class="string">&lt;meta</span> <span class="string">name=&quot;description&quot;</span> <span class="string">content=&quot;&quot;&gt;</span></span><br><span class="line">        <span class="string">&lt;meta</span> <span class="string">name=&quot;author&quot;</span> <span class="string">content=&quot;&quot;&gt;</span></span><br><span class="line">        <span class="string">&lt;title&gt;Signin&lt;/title&gt;</span></span><br><span class="line">        <span class="string">&lt;!--</span> <span class="string">Bootstrap</span> <span class="string">core</span> <span class="string">CSS</span> <span class="string">--&gt;</span></span><br><span class="line">        <span class="string">&lt;link</span> <span class="string">href=&quot;https://cdn.bootcss.com/bootstrap/3.3.7/css/bootstrap.min.css&quot;</span> <span class="string">rel=&quot;stylesheet&quot;&gt;</span></span><br><span class="line">        <span class="string">&lt;style&gt;</span></span><br><span class="line">            <span class="string">.divcss&#123;text-align:center&#125;</span></span><br><span class="line">            <span class="string">.sr-only</span> &#123;<span class="attr">position:</span> <span class="string">absolute;width:</span> <span class="string">1px;height:</span> <span class="string">1px;padding:</span> <span class="number">0</span><span class="string">;margin:</span> <span class="string">-1px;overflow:</span> <span class="string">hidden;clip:</span> <span class="string">rect(0</span>,<span class="number">0</span>,<span class="number">0</span>,<span class="number">0</span><span class="string">);border:</span> <span class="number">0</span><span class="string">;</span>&#125;</span><br><span class="line">            <span class="string">.form-signin</span> <span class="string">.form-control</span> &#123;<span class="attr">position:</span> <span class="string">relative;height:</span> <span class="string">auto;-webkit-box-sizing:</span> <span class="string">border-box;-moz-box-sizing:</span> <span class="string">border-box;</span></span><br><span class="line">                <span class="attr">box-sizing:</span> <span class="string">border-box;padding:</span> <span class="string">10px;font-size:</span> <span class="string">16px;</span>&#125;</span><br><span class="line">            <span class="string">.form-control</span> &#123;<span class="attr">display:</span> <span class="string">block;width:</span> <span class="number">100</span><span class="string">%;height:</span> <span class="string">34px;padding:</span> <span class="string">6px</span> <span class="string">12px;font-size:</span> <span class="string">14px;line-height:</span> <span class="number">1.42857143</span><span class="string">;</span></span><br><span class="line">                <span class="attr">color:</span> <span class="comment">#555;background-color: #fff;background-image: none;border: 1px solid #ccc;border-radius: 4px;</span></span><br><span class="line">                <span class="string">-webkit-box-shadow:</span> <span class="string">inset</span> <span class="number">0</span> <span class="string">1px</span> <span class="string">1px</span> <span class="string">rgb(0</span> <span class="number">0</span> <span class="number">0</span> <span class="string">//</span> <span class="number">8</span><span class="string">%);box-shadow:</span> <span class="string">inset</span> <span class="number">0</span> <span class="string">1px</span> <span class="string">1px</span> <span class="string">rgb(0</span> <span class="number">0</span> <span class="number">0</span> <span class="string">//</span> <span class="number">8</span><span class="string">%);</span></span><br><span class="line">                <span class="string">-webkit-transition:</span> <span class="string">border-color</span> <span class="string">ease-in-out</span> <span class="string">.15s</span>,<span class="string">-webkit-box-shadow</span> <span class="string">ease-in-out</span> <span class="string">.15s;</span></span><br><span class="line">                <span class="string">-o-transition:</span> <span class="string">border-color</span> <span class="string">ease-in-out</span> <span class="string">.15s</span>,<span class="string">box-shadow</span> <span class="string">ease-in-out</span> <span class="string">.15s;transition:</span> <span class="string">border-color</span> <span class="string">ease-in-out</span> <span class="string">.15s</span>,<span class="string">box-shadow</span> <span class="string">ease-in-out</span> <span class="string">.15s;</span>&#125;</span><br><span class="line">            <span class="string">.btn-block</span> &#123;<span class="attr">display:</span> <span class="string">block;width:</span> <span class="number">100</span><span class="string">%;</span>&#125;</span><br><span class="line">            <span class="string">.btn-primary</span> &#123;<span class="attr">color:</span> <span class="comment">#fff;background-color: #337ab7;border-color: #2e6da4;&#125;</span></span><br><span class="line">            <span class="string">.btn</span> &#123;<span class="attr">display:</span> <span class="string">inline-block;padding:</span> <span class="string">6px</span> <span class="string">12px;margin-bottom:</span> <span class="number">0</span><span class="string">;font-size:</span> <span class="string">14px;font-weight:</span> <span class="number">400</span><span class="string">;</span></span><br><span class="line">                <span class="attr">line-height:</span> <span class="number">1.42857143</span><span class="string">;text-align:</span> <span class="string">center;white-space:</span> <span class="string">nowrap;vertical-align:</span> <span class="string">middle;-ms-touch-action:</span> <span class="string">manipulation;</span></span><br><span class="line">                <span class="attr">touch-action:</span> <span class="string">manipulation;cursor:</span> <span class="string">pointer;-webkit-user-select:</span> <span class="string">none;-moz-user-select:</span> <span class="string">none;-ms-user-select:</span> <span class="string">none;</span></span><br><span class="line">                <span class="attr">user-select:</span> <span class="string">none;background-image:</span> <span class="string">none;border:</span> <span class="string">1px</span> <span class="string">solid</span> <span class="string">transparent;border-radius:</span> <span class="string">4px;</span>&#125;</span><br><span class="line">            <span class="string">.btn-lg</span> &#123;<span class="attr">padding:</span> <span class="string">10px</span> <span class="string">16px;font-size:</span> <span class="string">18px;line-height:</span> <span class="number">1.3333333</span><span class="string">;border-radius:</span> <span class="string">6px;</span>&#125;</span><br><span class="line">            <span class="string">.form-signin</span> &#123;<span class="attr">max-width:</span> <span class="string">330px;padding:</span> <span class="string">15px;margin:</span> <span class="number">0</span> <span class="string">auto;</span>&#125;</span><br><span class="line"></span><br><span class="line">            <span class="string">.copyright</span> &#123;<span class="attr">background:</span> <span class="comment">#fff;&#125;</span></span><br><span class="line">            <span class="comment">#footer .copyright &#123;background: #fff;padding-top: 20px;padding-bottom: 20px;margin-top: 20px;</span></span><br><span class="line">                <span class="string">-moz-box-shadow:</span> <span class="number">0</span> <span class="string">-1px</span> <span class="string">1px</span> <span class="comment">#ececec;box-shadow: 0 -1px 1px #ececec;&#125;</span></span><br><span class="line">            <span class="string">.copyright</span> &#123;<span class="attr">font-size:</span> <span class="string">12px;color:</span> <span class="comment">#999;margin: 0 auto;width: 100%;text-align: center;padding: 20px 0;&#125;</span></span><br><span class="line">            <span class="string">.copyright</span>, <span class="string">.fivecol</span> &#123;<span class="attr">width:</span> <span class="number">14</span><span class="string">%;</span>&#125;</span><br><span class="line">        <span class="string">&lt;/style&gt;</span></span><br><span class="line">      <span class="string">&lt;/head&gt;</span></span><br><span class="line">      <span class="string">&lt;body</span> <span class="string">&gt;</span></span><br><span class="line">        <span class="string">&lt;div</span> <span class="string">class=&quot;container&quot;&gt;</span></span><br><span class="line">          <span class="string">&lt;form</span> <span class="string">class=&quot;form-signin&quot;</span> <span class="string">method=&quot;post&quot;&gt;</span></span><br><span class="line">            <span class="string">&lt;h2</span> <span class="string">class=&quot;divcss&quot;&gt;登录页面&lt;/h2&gt;</span></span><br><span class="line">            <span class="string">&lt;label</span> <span class="string">for=&quot;inputUsername&quot;</span> <span class="string">class=&quot;sr-only&quot;&gt;用户名&lt;/label&gt;</span></span><br><span class="line">            <span class="string">&lt;input</span> <span class="string">type=&quot;text&quot;</span> <span class="string">id=&quot;inputUsername&quot;</span> <span class="string">class=&quot;form-control&quot;</span> <span class="string">placeholder=&quot;用户名&quot;</span> <span class="string">required=&quot;&quot;</span> <span class="string">autofocus=&quot;&quot;</span> <span class="string">name=&quot;Username&quot;&gt;</span></span><br><span class="line">            <span class="string">&lt;label</span> <span class="string">for=&quot;inputPassword&quot;</span> <span class="string">class=&quot;sr-only&quot;&gt;密码&lt;/label&gt;</span></span><br><span class="line">            <span class="string">&lt;input</span> <span class="string">type=&quot;password&quot;</span> <span class="string">id=&quot;inputPassword&quot;</span> <span class="string">class=&quot;form-control&quot;</span> <span class="string">placeholder=&quot;密码&quot;</span> <span class="string">required=&quot;&quot;</span> <span class="string">name=&quot;Password&quot;&gt;</span></span><br><span class="line">            <span class="string">&lt;div</span> <span class="string">class=&quot;checkbox&quot;&gt;</span></span><br><span class="line">              <span class="string">&lt;label&gt;</span></span><br><span class="line">                <span class="string">&lt;input</span> <span class="string">type=&quot;checkbox&quot;</span> <span class="string">value=&quot;remember-me&quot;&gt;</span> <span class="string">记住用户名密码</span></span><br><span class="line">              <span class="string">&lt;/label&gt;</span></span><br><span class="line">            <span class="string">&lt;/div&gt;</span></span><br><span class="line">            <span class="string">&lt;button</span> <span class="string">class=&quot;btn</span> <span class="string">btn-lg</span> <span class="string">btn-primary</span> <span class="string">btn-block&quot;</span> <span class="string">type=&quot;submit&quot;&gt;登录&lt;/button&gt;</span></span><br><span class="line">          <span class="string">&lt;/form&gt;</span></span><br><span class="line">            <span class="string">&lt;h3</span> <span class="string">class=&quot;divcss&quot;&gt;</span> &#123;&#123; <span class="string">get_flashed_messages()</span>[<span class="number">0</span>] &#125;&#125; <span class="string">&lt;/h3&gt;</span></span><br><span class="line">        <span class="string">&lt;/div&gt;</span></span><br><span class="line"></span><br><span class="line">        <span class="string">&lt;div</span> <span class="string">class=&quot;copyright&quot;&gt;</span></span><br><span class="line">        <span class="string">Copyright</span> <span class="string">©</span> <span class="number">2013</span><span class="number">-2021</span>    <span class="string">&lt;strong&gt;</span></span><br><span class="line">            <span class="string">&lt;a</span> <span class="string">href=&quot;//semaik.gitee.io/&quot;</span> <span class="string">target=&quot;_blank&quot;&gt;菜鸟登录页&lt;/a&gt;</span></span><br><span class="line">        <span class="string">&lt;/strong&gt;&amp;nbsp;</span></span><br><span class="line">        <span class="string">&lt;strong&gt;</span></span><br><span class="line">            <span class="string">&lt;a</span> <span class="string">href=&quot;//semaik.gitee.io/&quot;</span> <span class="string">target=&quot;_blank&quot;&gt;Semaik.gitee.io&lt;/a&gt;</span></span><br><span class="line">        <span class="string">&lt;/strong&gt;</span> <span class="string">All</span> <span class="string">Rights</span> <span class="string">Reserved.</span> <span class="string">备案号：</span></span><br><span class="line">            <span class="string">&lt;a</span> <span class="string">target=&quot;_blank&quot;</span> <span class="string">rel=&quot;nofollow&quot;</span> <span class="string">href=&quot;https://beian.miit.gov.cn/&quot;&gt;京ICP备15012807号-1&lt;/a&gt;</span></span><br><span class="line">      <span class="string">&lt;/div&gt;</span></span><br><span class="line">      <span class="string">&lt;/body&gt;</span></span><br><span class="line">    <span class="string">&lt;/html&gt;</span></span><br><span class="line"></span><br><span class="line"><span class="meta">---</span></span><br><span class="line"><span class="comment"># 部署nginx</span></span><br><span class="line"><span class="attr">apiVersion:</span> <span class="string">apps/v1</span></span><br><span class="line"><span class="attr">kind:</span> <span class="string">Deployment</span></span><br><span class="line"><span class="attr">metadata:</span></span><br><span class="line">  <span class="attr">name:</span> <span class="string">nginx2</span></span><br><span class="line">  <span class="attr">namespace:</span> <span class="string">nginx-ns</span></span><br><span class="line"><span class="attr">spec:</span></span><br><span class="line">  <span class="attr">replicas:</span> <span class="number">3</span></span><br><span class="line">  <span class="attr">selector:</span></span><br><span class="line">    <span class="attr">matchLabels:</span></span><br><span class="line">      <span class="attr">app:</span> <span class="string">nginx-dp</span></span><br><span class="line">  <span class="attr">template:</span></span><br><span class="line">    <span class="attr">metadata:</span></span><br><span class="line">      <span class="attr">labels:</span></span><br><span class="line">        <span class="attr">app:</span> <span class="string">nginx-dp</span></span><br><span class="line">    <span class="attr">spec:</span></span><br><span class="line">      <span class="attr">containers:</span></span><br><span class="line">      <span class="bullet">-</span> <span class="attr">name:</span> <span class="string">nginx-dp</span></span><br><span class="line">        <span class="attr">image:</span> <span class="string">nginx:1.20</span></span><br><span class="line">        <span class="attr">ports:</span></span><br><span class="line">        <span class="bullet">-</span> <span class="attr">containerPort:</span> <span class="number">80</span></span><br><span class="line">        <span class="attr">volumeMounts:</span></span><br><span class="line">        <span class="bullet">-</span> <span class="attr">name:</span> <span class="string">nginx-html</span></span><br><span class="line">          <span class="attr">mountPath:</span> <span class="string">/usr/share/nginx/html</span></span><br><span class="line">      <span class="attr">volumes:</span></span><br><span class="line">      <span class="bullet">-</span> <span class="attr">name:</span> <span class="string">nginx-html</span></span><br><span class="line">        <span class="attr">configMap:</span></span><br><span class="line">          <span class="attr">name:</span> <span class="string">nginx-html</span></span><br><span class="line"></span><br><span class="line"><span class="meta">---</span></span><br><span class="line"><span class="comment"># 部署svc</span></span><br><span class="line"><span class="attr">apiVersion:</span> <span class="string">v1</span></span><br><span class="line"><span class="attr">kind:</span> <span class="string">Service</span></span><br><span class="line"><span class="attr">metadata:</span></span><br><span class="line">  <span class="attr">name:</span> <span class="string">nginx-svc</span></span><br><span class="line">  <span class="attr">namespace:</span> <span class="string">nginx-ns</span></span><br><span class="line"><span class="attr">spec:</span> </span><br><span class="line">  <span class="attr">selector:</span></span><br><span class="line">    <span class="attr">app:</span> <span class="string">nginx-dp</span></span><br><span class="line">  <span class="attr">ports:</span></span><br><span class="line">  <span class="bullet">-</span> <span class="attr">name:</span> <span class="string">nginx-svc</span></span><br><span class="line">    <span class="attr">port:</span> <span class="number">80</span></span><br><span class="line">    <span class="attr">targetPort:</span> <span class="number">80</span></span><br><span class="line">    </span><br><span class="line">[<span class="string">root@pool1</span> <span class="string">k8s_yaml</span>]<span class="comment"># kubectl apply -f nginx2-pod.yaml</span></span><br><span class="line"></span><br><span class="line">[<span class="string">root@pool1</span> <span class="string">k8s_yaml</span>]<span class="comment"># kubectl get pod -n nginx-ns</span></span><br><span class="line"><span class="string">NAME</span>                     <span class="string">READY</span>   <span class="string">STATUS</span>    <span class="string">RESTARTS</span>   <span class="string">AGE</span></span><br><span class="line"><span class="string">nginx2-8759f5648-5ms8l</span>   <span class="number">1</span><span class="string">/1</span>     <span class="string">Running</span>   <span class="number">0</span>          <span class="string">11m</span></span><br><span class="line"><span class="string">nginx2-8759f5648-t26wx</span>   <span class="number">1</span><span class="string">/1</span>     <span class="string">Running</span>   <span class="number">0</span>          <span class="string">11m</span></span><br><span class="line"><span class="string">nginx2-8759f5648-w2f84</span>   <span class="number">1</span><span class="string">/1</span>     <span class="string">Running</span>   <span class="number">0</span>          <span class="string">11m</span></span><br></pre></td></tr></table></figure>
<h4 id="部署Ingress-控制器"><a href="#部署Ingress-控制器" class="headerlink" title="部署Ingress 控制器"></a>部署Ingress 控制器</h4><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br></pre></td><td class="code"><pre><span class="line">[root@pool1 k8s_yaml]<span class="comment"># vi Ingress-nginx-0.46.0.yaml</span></span><br><span class="line">……</span><br><span class="line">kind: DaemonSet <span class="comment"># 这里改成DaemonSet，使得所有节点都部署ingress controller 或者给节点打标签使用Deployment来部署；</span></span><br><span class="line">      hostNetwork: <span class="literal">true</span>  <span class="comment"># 应用宿主机网络</span></span><br><span class="line">      containers:</span><br><span class="line">        - name: controller</span><br><span class="line">          image: acicn/ingress-nginx-controller:v0.46.0 <span class="comment"># 修改镜像</span></span><br><span class="line">          imagePullPolicy: IfNotPresent</span><br><span class="line"></span><br><span class="line">……</span><br><span class="line">[root@pool1 k8s_yaml]<span class="comment"># kubectl apply -f Ingress-nginx-0.46.0.yaml</span></span><br><span class="line"></span><br><span class="line">[root@pool1 k8s_yaml]<span class="comment"># kubectl get pod -n ingress-nginx -o wide</span></span><br><span class="line">NAME                                   READY   STATUS      RESTARTS   AGE    IP              NODE    NOMINATED NODE   READINESS GATES</span><br><span class="line">ingress-nginx-admission-create-kqprw   0/1     Completed   0          8m4s   10.244.206.9    pool3   &lt;none&gt;           &lt;none&gt;</span><br><span class="line">ingress-nginx-admission-patch-22snb    0/1     Completed   3          8m4s   10.244.52.198   pool2   &lt;none&gt;           &lt;none&gt;</span><br><span class="line">ingress-nginx-controller-wl6c7         1/1     Running     0          8m4s   172.16.1.22     pool3   &lt;none&gt;           &lt;none&gt;</span><br><span class="line">ingress-nginx-controller-x4xvx         1/1     Running     0          8m4s   172.16.1.21     pool2   &lt;none&gt;           &lt;none&gt;</span><br></pre></td></tr></table></figure>
<h4 id="部署Ingress-Pod"><a href="#部署Ingress-Pod" class="headerlink" title="部署Ingress Pod"></a>部署Ingress Pod</h4><figure class="highlight yaml"><table><tr><td class="gutter"><pre><span class="line">1</span><br><span class="line">2</span><br><span class="line">3</span><br><span class="line">4</span><br><span class="line">5</span><br><span class="line">6</span><br><span class="line">7</span><br><span class="line">8</span><br><span class="line">9</span><br><span class="line">10</span><br><span class="line">11</span><br><span class="line">12</span><br><span class="line">13</span><br><span class="line">14</span><br><span class="line">15</span><br><span class="line">16</span><br><span class="line">17</span><br><span class="line">18</span><br><span class="line">19</span><br><span class="line">20</span><br><span class="line">21</span><br><span class="line">22</span><br><span class="line">23</span><br><span class="line">24</span><br></pre></td><td class="code"><pre><span class="line">[<span class="string">root@pool1</span> <span class="string">k8s_yaml</span>]<span class="comment"># vi nginx2-ingress.yaml </span></span><br><span class="line"><span class="attr">apiVersion:</span> <span class="string">networking.k8s.io/v1</span></span><br><span class="line"><span class="attr">kind:</span> <span class="string">Ingress</span></span><br><span class="line"><span class="attr">metadata:</span></span><br><span class="line">  <span class="attr">name:</span> <span class="string">nginx2-ingress</span></span><br><span class="line">  <span class="attr">namespace:</span> <span class="string">nginx-ns</span></span><br><span class="line"><span class="attr">spec:</span></span><br><span class="line">  <span class="attr">rules:</span></span><br><span class="line">  <span class="bullet">-</span> <span class="attr">host:</span> <span class="string">zux.nginx2.com</span> <span class="comment"># 域名</span></span><br><span class="line">    <span class="attr">http:</span></span><br><span class="line">      <span class="attr">paths:</span></span><br><span class="line">      <span class="bullet">-</span> <span class="attr">pathType:</span> <span class="string">Prefix</span></span><br><span class="line">        <span class="attr">path:</span> <span class="string">/</span>  <span class="comment"># 首页路径</span></span><br><span class="line">        <span class="attr">backend:</span></span><br><span class="line">          <span class="attr">service:</span></span><br><span class="line">            <span class="attr">name:</span> <span class="string">nginx-svc</span> <span class="comment"># svc名称</span></span><br><span class="line">            <span class="attr">port:</span></span><br><span class="line">              <span class="attr">number:</span> <span class="number">80</span> <span class="comment"># svc端口</span></span><br><span class="line">              </span><br><span class="line">[<span class="string">root@pool1</span> <span class="string">k8s_yaml</span>]<span class="comment"># kubectl apply -f nginx2-ingress.yaml </span></span><br><span class="line"></span><br><span class="line">[<span class="string">root@pool1</span> <span class="string">k8s_yaml</span>]<span class="comment"># kubectl get ingress -n nginx-ns</span></span><br><span class="line"><span class="string">NAME</span>             <span class="string">CLASS</span>    <span class="string">HOSTS</span>            <span class="string">ADDRESS</span>                   <span class="string">PORTS</span>   <span class="string">AGE</span></span><br><span class="line"><span class="string">nginx2-ingress</span>   <span class="string">&lt;none&gt;</span>   <span class="string">zux.nginx2.com</span>   <span class="number">172.16</span><span class="number">.1</span><span class="number">.21</span><span class="string">,172.16.1.22</span>   <span class="number">80</span>      <span class="string">26m</span></span><br></pre></td></tr></table></figure>
<h4 id="域名解析"><a href="#域名解析" class="headerlink" title="域名解析"></a>域名解析</h4><figure class="highlight sh"><table><tr><td class="gutter"><pre><span class="line">1</span><br></pre></td><td class="code"><pre><span class="line">[root@pool1 k8s_yaml]<span class="comment"># echo &quot;172.16.1.23 zux.nginx2.com&quot; &gt;&gt; /etc/hosts</span></span><br></pre></td></tr></table></figure>
<p>Windows：C:\Windows\System32\drivers\etc\hosts</p>
</article><div class="post-copyright"><div class="post-copyright__author"><span class="post-copyright-meta">文章作者: </span><span class="post-copyright-info"><a href="mailto:undefined">ZuSir</a></span></div><div class="post-copyright__type"><span class="post-copyright-meta">文章链接: </span><span class="post-copyright-info"><a href="http://example.com/2021/08/27/Ingress-HTTP%E4%BB%A3%E7%90%86%E8%AE%BF%E9%97%AE/">http://example.com/2021/08/27/Ingress-HTTP%E4%BB%A3%E7%90%86%E8%AE%BF%E9%97%AE/</a></span></div><div class="post-copyright__notice"><span class="post-copyright-meta">版权声明: </span><span class="post-copyright-info">本博客所有文章除特别声明外，均采用 <a href="https://creativecommons.org/licenses/by-nc-sa/4.0/" target="_blank">CC BY-NC-SA 4.0</a> 许可协议。转载请注明来自 <a href="http://example.com" target="_blank">SeMaik</a>！</span></div></div><div class="tag_share"><div class="post-meta__tag-list"></div><div class="post_share"><div class="social-share" data-image="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" data-sites="facebook,twitter,wechat,weibo,qq"></div><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/social-share.js/dist/css/share.min.css" media="print" onload="this.media='all'"><script src="https://cdn.jsdelivr.net/npm/social-share.js/dist/js/social-share.min.js" defer></script></div></div><nav class="pagination-post" id="pagination"><div class="prev-post pull-left"><a href="/2021/08/27/kubeadm%E4%BF%AE%E6%94%B9ipvs%E8%BD%AC%E5%8F%91%E6%A8%A1%E5%BC%8F/"><img class="prev-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of previous post"><div class="pagination-info"><div class="label">上一篇</div><div class="prev_info">kubeadm修改ipvs转发模式</div></div></a></div><div class="next-post pull-right"><a href="/2021/06/10/%E9%83%A8%E7%BD%B2Harbor%E9%95%9C%E5%83%8F%E4%BB%93%E5%BA%93/"><img class="next-cover" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/img/default.jpg" onerror="onerror=null;src='/img/123.jpeg'" alt="cover of next post"><div class="pagination-info"><div class="label">下一篇</div><div class="next_info">部署企业级Harbor镜像仓库</div></div></a></div></nav></div><div class="aside-content" id="aside-content"><div class="card-widget card-info"><div class="card-info-avatar is-center"><img class="avatar-img" src="/img/123.jpeg" onerror="this.onerror=null;this.src='/img/123.jpeg'" alt="avatar"/><div class="author-info__name">ZuSir</div><div class="author-info__description">一个收藏回忆与分享技术的地方!</div></div><div class="card-info-data"><div class="card-info-data-item is-center"><a href="/archives/"><div class="headline">文章</div><div class="length-num">152</div></a></div><div class="card-info-data-item is-center"><a href="/categories/"><div class="headline">分类</div><div class="length-num">37</div></a></div></div></div><div class="card-widget card-announcement"><div class="item-headline"><i class="fas fa-bullhorn card-announcement-animation"></i><span>公告</span></div><div class="announcement_content">This is my Blog! <img src="https://ss0.bdstatic.com/70cFuHSh_Q1YnxGkpoWK1HF6hhy/it/u=3894415926,2787041726&fm=26&gp=0.jpg"></div></div><div class="sticky_layout"><div class="card-widget" id="card-toc"><div class="item-headline"><i class="fas fa-stream"></i><span>目录</span></div><div class="toc-content"><ol class="toc"><li class="toc-item toc-level-3"><a class="toc-link" href="#%E6%9C%89%E4%BA%86NodePort%E4%B8%BA%E4%BB%80%E4%B9%88%E7%94%A8Ingress%EF%BC%9F"><span class="toc-number">1.</span> <span class="toc-text">有了NodePort为什么用Ingress？</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Ingrass-Controller%E6%98%AF%E4%BB%80%E4%B9%88%EF%BC%9F"><span class="toc-number">2.</span> <span class="toc-text">Ingrass Controller是什么？</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Ingress%E6%98%AF%E4%BB%80%E4%B9%88%EF%BC%9F"><span class="toc-number">3.</span> <span class="toc-text">Ingress是什么？</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#Ingress%E4%BD%BF%E7%94%A8%E6%B5%81%E7%A8%8B%EF%BC%9A"><span class="toc-number">4.</span> <span class="toc-text">Ingress使用流程：</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#ingress%E4%B8%A4%E7%A7%8D%E8%BD%AC%E5%8F%91%E6%A8%A1%E5%BC%8F"><span class="toc-number">5.</span> <span class="toc-text">ingress两种转发模式</span></a></li><li class="toc-item toc-level-3"><a class="toc-link" href="#%E9%AB%98%E5%8F%AF%E7%94%A8Ingress%E6%BC%94%E7%A4%BA-http%E4%BB%A3%E7%90%86%E8%AE%BF%E9%97%AE"><span class="toc-number">6.</span> <span class="toc-text">高可用Ingress演示(http代理访问)</span></a><ol class="toc-child"><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2keepalived"><span class="toc-number">6.1.</span> <span class="toc-text">部署keepalived</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%88%9B%E5%BB%BAnginx-pod"><span class="toc-number">6.2.</span> <span class="toc-text">创建nginx pod</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2Ingress-%E6%8E%A7%E5%88%B6%E5%99%A8"><span class="toc-number">6.3.</span> <span class="toc-text">部署Ingress 控制器</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E9%83%A8%E7%BD%B2Ingress-Pod"><span class="toc-number">6.4.</span> <span class="toc-text">部署Ingress Pod</span></a></li><li class="toc-item toc-level-4"><a class="toc-link" href="#%E5%9F%9F%E5%90%8D%E8%A7%A3%E6%9E%90"><span class="toc-number">6.5.</span> <span class="toc-text">域名解析</span></a></li></ol></li></ol></div></div><div class="card-widget card-recent-post"><div class="item-headline"><i class="fas fa-history"></i><span>最新文章</span></div><div class="aside-list"><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Zabbix-Server5-0/" title="Shell程序——部署Zabbix-ServerV5.0">Shell程序——部署Zabbix-ServerV5.0</a><time datetime="2022-02-17T03:32:00.000Z" title="发表于 2022-02-17 11:32:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E9%83%A8%E7%BD%B2Harbor/" title="Shell程序——部署Harbor">Shell程序——部署Harbor</a><time datetime="2022-02-17T03:31:00.000Z" title="发表于 2022-02-17 11:31:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94Mysql%E5%A4%87%E4%BB%BD/" title="Shell程序——Mysql备份">Shell程序——Mysql备份</a><time datetime="2022-02-17T03:30:00.000Z" title="发表于 2022-02-17 11:30:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E6%89%B9%E9%87%8F%E4%BF%9D%E5%AD%98Docker-image/" title="Shell程序——批量保存Docker_image">Shell程序——批量保存Docker_image</a><time datetime="2022-02-17T03:29:00.000Z" title="发表于 2022-02-17 11:29:00">2022-02-17</time></div></div><div class="aside-list-item no-cover"><div class="content"><a class="title" href="/2022/02/17/Shell%E2%80%94%E2%80%94%E5%85%A8%E6%AE%B5IP%E6%89%AB%E6%8F%8F/" title="Shell程序——全段IP扫描">Shell程序——全段IP扫描</a><time datetime="2022-02-17T03:28:00.000Z" title="发表于 2022-02-17 11:28:00">2022-02-17</time></div></div></div></div></div></div></main><footer id="footer"><div id="footer-wrap"><div class="copyright">&copy;2020 - 2022 By ZuSir</div><div class="framework-info"><span>框架 </span><a target="_blank" rel="noopener" href="https://hexo.io">Hexo</a><span class="footer-separator">|</span><span>主题 </span><a target="_blank" rel="noopener" href="https://github.com/jerryc127/hexo-theme-butterfly">Butterfly</a></div></div></footer></div><div id="rightside"><div id="rightside-config-hide"><button id="readmode" type="button" title="阅读模式"><i class="fas fa-book-open"></i></button><button id="hide-aside-btn" type="button" title="单栏和双栏切换"><i class="fas fa-arrows-alt-h"></i></button></div><div id="rightside-config-show"><button id="rightside_config" type="button" title="设置"><i class="fas fa-cog fa-spin"></i></button><button class="close" id="mobile-toc-button" type="button" title="目录"><i class="fas fa-list-ul"></i></button><button id="go-up" type="button" title="回到顶部"><i class="fas fa-arrow-up"></i></button></div></div><div><script src="/js/utils.js"></script><script src="/js/main.js"></script><div class="js-pjax"></div><script defer="defer" id="fluttering_ribbon" mobile="true" src="https://cdn.jsdelivr.net/npm/butterfly-extsrc@1/dist/canvas-fluttering-ribbon.min.js"></script><script async data-pjax src="//busuanzi.ibruce.info/busuanzi/2.3/busuanzi.pure.mini.js"></script></div></body></html>